// WISEE.cpp : AvP[VpNX̒`s܂B
//

#include "stdafx.h"
#include "WISEE.h"
#include "WiseeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TCHAR	g_LogFileName[MAX_PATH];


//*****************************************************************************
//
//	RestoreWindowProc
//		hWnd			--- WindowsEBhEnh
//		lParam			--- EBhE̖O
//
// EBhE񋓃R[obN֐
// dNɈȑOɋNĂ̂𕜌
//
//*****************************************************************************
BOOL CALLBACK RestoreWindowProc( HWND hWnd, LPARAM lParam )
{
	TCHAR szWindowName[MAX_PATH];
	TCHAR* szSWN;
	szSWN = (TCHAR*)lParam;

	GetWindowText(hWnd, szWindowName, sizeof(szWindowName));

	if( szWindowName[0] == '\0' )
		return TRUE;

	if(_tcscmp(szWindowName,(LPCTSTR)lParam) == 0)
	{
		SendMessage(hWnd,WM_SYSCOMMAND, SC_RESTORE,0);
		return FALSE;
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CWiseeApp

BEGIN_MESSAGE_MAP(CWiseeApp, CWinApp)
	//{{AFX_MSG_MAP(CWiseeApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWiseeApp NX̍\z

CWiseeApp::CWiseeApp()
{
	// TODO: ̈ʒuɍ\zp̃R[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	ZeroMemory(g_LogFileName, MAX_PATH );
}

/////////////////////////////////////////////////////////////////////////////
// B CWiseeApp IuWFNg

CWiseeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWiseeApp NX̏

BOOL CWiseeApp::InitInstance()
{
	// WIȏ
	// ̋@\gpAst@C̃TCY
	//  Έȉ̓̏[`̒sKvȂ̂폜
	//  B
	
	//------------ g̓dN̋֎~ ------------------
	HANDLE	hPrevMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, APPNAME );

	if( hPrevMutex )
	{
		CloseHandle( hPrevMutex );
		// ɋNĂEBhEXgAĂ
		EnumWindows( RestoreWindowProc, (LPARAM)WINDOWCAPTION);
		return FALSE;
	}
	
	hPrevMutex = CreateMutex( FALSE, 0, APPNAME );
	//------------ g̓dN֎~I ------------


#ifdef _AFXDLL
	Enable3dControls();			// L DLL  MFC gꍇ͂R[ĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNꍇ͂R[ĂB
#endif

	BOOL bHide;
	DWORD nLogSize;
	DWORD nInterval;
	if( !GetAppOption( &bHide, &nLogSize, &g_LogFileName[0], &nInterval ) )
		return FALSE;

	CWiseeDlg dlg;
	m_pMainWnd = &dlg;
	dlg.m_bHide=bHide;
	dlg.m_nLogSize=nLogSize;
	dlg.m_nInterval=nInterval;

	int nResponse = dlg.DoModal();

	this->m_nCmdShow = SW_HIDE;
	return FALSE;
}


//*****************************************************************************
//
//	GetAppOption
//
//	ÑIvV擾
//
//*****************************************************************************
BOOL CWiseeApp::GetAppOption( 
	BOOL* bHide,			// NɃEBhE\ɂ
	DWORD* nLogSize,		// Ot@C̐؂ւTCY
	TCHAR* lpszLogPath,		// Ot@C
	DWORD* nInterval		// EBhE񋓊Ԋu
	)
{
	// default value
	*bHide = TRUE;
	*nLogSize = 1024;
	*nInterval = 5;

	TCHAR	string[256];
	TCHAR	seps[] = " \t,";
	TCHAR	*token;
	
	strncpy( string, (LPCTSTR)m_lpCmdLine, 255 );

	/* bZ[W啶 */
	for( TCHAR *p = string; p < string + strlen( string ); p++ )
	{
		if( islower( *p ) )
			*p = _toupper( *p );
	}

	/* ŏ̃g[N擾܂B */
	token = strtok( string, seps );
	while( token != NULL )
	{
		/* "string" Ƀg[NȂȂ܂ŌJԂ܂B */
		// IvV
		if( (token[0] == '/') || (token[0] == '-') )
		{
			// LOGSIZE
			if( strcmp( &token[1], _T("LOGSIZE") ) == 0 )
			{
				token = strtok( NULL, seps );
				*nLogSize = atoi( token );
				if( *nLogSize < 1 )			// under 1KB
					*nLogSize = 1;
				if( *nLogSize > 1024*31 )	// over 31M
					*nLogSize = 1024*31;

			}
			// INTERVAL
			else if( strcmp( &token[1], _T("INTERVAL") ) == 0 )
			{
				token = strtok( NULL, seps );
				*nInterval = atoi( token );
				if( *nInterval < 1 )			// under 1sec
					*nInterval = 1;
				if( *nInterval > 600 )			// over 600sec
					*nInterval = 600;

			}
			// LOGFILE PATH
			else if( strcmp( &token[1], _T("LOGPATH") ) == 0 )
			{
				token = strtok( NULL, seps );
				strncpy( lpszLogPath, token, MAX_PATH-1 );
			}
			// SHOW_HIDE OPTION
			else if( strcmp( &token[1], _T("SHOW") ) == 0 )
			{
				*bHide = FALSE;
			}
			// HELP
			else if( strcmp( &token[1], _T("?") ) == 0 )
			{
				AfxMessageBox( _T("usage:\n[/LOGSIZE]nnnnnn(KB)]\n[/INTERVAL]nnn\n[/SHOW]\n[/LOGPATH]filepath") );
				return FALSE;
			}

			else
			{
				AfxMessageBox( _T("option err\nTry /? option.") );
				return FALSE;
			}
		}
		/* ̃g[N擾܂B */
		token = strtok( NULL, seps );
	}
	return TRUE;
}


VOID	GetLogFileName( LPTSTR	pFileName )
{

	// Ot@Cw肳ĂȂftHg쐬
	if( g_LogFileName[0] == '\0' )
	{
		DWORD	retGMF =  GetModuleFileName(NULL, pFileName, MAX_PATH-5);
	
		if( (MAX_PATH-5) < retGMF ||		// filename, too long.
			retGMF == 0	)					// API error.
		{
			pFileName[0] = '0';
			return;
		}
		_tcscat(pFileName, _T(".log"));
	}
	else
	{
		_tcsncpy(pFileName, g_LogFileName, MAX_PATH-1);
	}

}

BOOL	WriteLog(LPCTSTR str)
{
	// ----------------------
	// Ot@C
	TCHAR	szLogName[MAX_PATH];
	GetLogFileName(szLogName);

	CString	strLog;
	CStdioFile f;
	if( !f.Open(szLogName, 
		CFile::modeNoTruncate | 
		CFile::modeCreate | 
		CFile::modeWrite | 
		CFile::typeText ))
	{
		f.Abort();
		return FALSE;
	}
	// ----------------------
	f.SeekToEnd();

	// Ԃ̏
	CTime tm = CTime::GetCurrentTime();
	CString strTime = tm.Format(_T("%Y/%m/%d %H:%M:%S,"));
	TRY
	{
		f.WriteString(strTime);
		f.WriteString(str);
		f.WriteString("\n");
	}
	CATCH( CFileException, e )
	{
		#ifdef _DEBUG
		afxDump << "File could not be opened "
			  << e->m_cause << "\n";
		#endif
		f.Abort();
		return FALSE;
	}
	END_CATCH

	f.Abort();
	return TRUE;
}
